VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsExplode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long

Private Type EXPLOSION  ' Explosion Data Type.
    exist As Boolean ' Exists or doesn't?
    x As Double      ' X coordinate to start the explosion at
    y As Double      ' Y coordinate to start the explosion at
    xvel As Double   ' X velocity
    yvel As Double   ' Y velocity
    r As Long        ' Red
    g As Long        ' Green
    b As Long        ' Blue
    rgb As Long      ' Color
    rate As Double   ' Rate of death
End Type

Dim exp(200) As EXPLOSION
Dim t As Variant

Public Sub NewExplosion(ByVal x As Double, ByVal y As Double, ByVal strength As Double, ByVal colorRED As Long, ByVal colorGREEN As Long, ByVal colorBLUE As Long)
' -------------------------------------------------------------------------------------------
' Setup a new explosion.
' -------------------------------------------------------------------------------------------
Dim numofparts As Long
Dim exx, exy

    exx = x
    exy = y
    numofparts = 140 + Rnd * 60

    For t = 1 To numofparts
        With exp(t)
            If Not .exist Then
                .exist = True
                .x = exx
                .y = exy
                .xvel = Rnd * strength - (strength / 2)
                .yvel = Rnd * strength - (strength / 2)
                .r = colorRED
                .g = colorGREEN
                .b = colorBLUE
                .rate = Rnd * 3 + 5
            End If
        End With
    Next t
End Sub

Public Sub Explode(ByRef surface As DirectDrawSurface2)
' -------------------------------------------------------------------------------------------
' Animates the Explosion sequence on
' a DirectDrawSurface passed in the surface parameter.
' -------------------------------------------------------------------------------------------
Dim hdcBackBuffer As Long
Dim i As Long

    For t = 0 To UBound(exp)
        If exp(t).exist Then
        With exp(t)
                If .b > 0 Or .g > 0 Then
                   .g = .g - .rate / (Rnd * 2 + 1)
                   .b = .b - .rate
                Else
                    .g = 0: .b = 0
                    .r = .r - .rate * Rnd
                End If
                If .r < 1 Then
                    .exist = False
                    .r = 0
                End If
                If .g < 0 Then .g = 0
                If .b < 0 Then .b = 0
        .rgb = rgb(Int(.r), Int(.g), Int(.b))
        
        .yvel = .yvel + 0.05
        .x = .x + .xvel
        .y = .y + .yvel
        If .y > 470 Then .yvel = .yvel * -(Rnd / 2 + 0.1): .y = 470
        End With
        End If
    Next t
    
    ' Treat events
    DoEvents
    
    ' Now display them.
    ' Get device context
    ' (don't trace from here until ReleaseDC)
    surface.GetDC hdcBackBuffer
    For i = 0 To UBound(exp)
        SetPixel hdcBackBuffer, exp(i).x, exp(i).y, exp(i).rgb
    Next i
    ' Release device context
    surface.ReleaseDC hdcBackBuffer
End Sub

Private Sub InitExplosion()
' -------------------------------------------------------------------------------------------
' THIS SUB IS ONLY USED BY THIS CLASS!
' -------------------------------------------------------------------------------------------
    For t = 1 To 100
        exp(t).exist = False
    Next t
End Sub

Private Sub Class_Initialize()
    InitExplosion
End Sub
